// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	test RmfEpochServer
//
#include <iostream>

#include "common.h"
#include "CalServer.h"
#include "RmfEpochServer.h"
#include "Xmm.h"

using namespace std;

int main(int argc, char **argv)
{

  // Status variable
  int worked = 0;

  RmfEpochServer * re = 0; re = calServer.getAtom(re);

/* MOS epochs */
  calServer.setInstrument(Xmm::EMOS1);

  const string oDate = "2000-01-01T01:01:01";
  short epoch = re->getRmfEpoch(oDate);
  cout << "MOS-1 Epoch: "<<epoch<<" from "<<oDate<<endl;

  if (epoch != 1)
     worked=1;

/* PN epoch */
  calServer.setInstrument(Xmm::EPN);
  epoch = re->getRmfEpoch(oDate);
  cout << "PN Epoch: "<<epoch<<" from "<<oDate<<endl;

  if (epoch != 1)
     worked=1;

	return worked;
}
