// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	test the cal rawx2mm calls
//
#include <fstream>
#include <iostream>
#include <iomanip>
#include "CalServer.h"
#include "Xmm.h"
#include "GeometryDataServer.h"
#include "common.h"

using namespace std;

int main()
{
	calServer.setInstrument(Xmm::RGS1);
	calServer.state()->randomize()->set(false);
	calServer.state()->ocb()->set(3);
	CalInt16Vector rawXVec(0, 344),
				   rawYVec(0, 344),
				   chipX(0, 344), chipY(0, 344);
	CalInt8Vector node(0, 344);
	for (unsigned rawX=1; rawX<=172; ++rawX) {
		rawXVec[rawX-1] = rawX;
		rawYVec[rawX-1] = 1;
		node[rawX-1] = 0;
	}
	for (unsigned rawX=172; rawX>=1; --rawX) {
		rawXVec[172+172-rawX] = rawX;
		rawYVec[172+172-rawX] = 1;
		node[172+172-rawX] = 1;
	}

	for (unsigned n=0; n<chipX.size(); ++n)
		cout<<rawXVec[n]<<endl;

	GeometryDataServer *cd = 0; cd = calServer.getAtom(cd);
	XmmPixelList pl = cd->pixCoord1List(rawXVec, rawYVec).toChipCoord(&node);
	XmmCartesianPointList cpl = pl.toCamCoord1();
	calServer.state()->ocb()->set(1);	//	set OCB to 1
	cpl.toChipCoord(chipX, chipY);

	for (unsigned n=0; n<chipX.size(); ++n)
		cout<<rawXVec[n]<<' '<<chipX[n]<<endl;

	return 0;
}
