// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
//	test the rgs background server
//
#include <iostream>
#include <cmath>
#include "CalServer.h"
#include "Xmm.h"
#include "RgsSolarAspectAngServer.h"

using namespace std;

static void process(XmmInstrument &rgsunit)
{
	cerr<<"Instrument: "<<Xmm::toString(rgsunit.id())<<endl;
	calServer.setInstrument(rgsunit.id());

	RgsSolarAspectAngServer *rsaa = 0; rsaa = calServer.getAtom(rsaa);

       // Find the coffeicients for order 1
        unsigned order = 1;
        vector<double> c = rsaa->coefficients(order);
        cout<<"Order 1 coeffs: "<<c[0]<<" "<<c[1]<<endl;

        order = 2;
        c = rsaa->coefficients(order);
        cout<<"Order 2 coeffs: "<<c[0]<<" "<<c[1]<<endl;

}

int main()
{
	process(xmmPayLoad.rgs1);
	process(xmmPayLoad.rgs2);

	return 0;
}

