! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!
!   caltest_misc.f90  --- f90 program to test the CAL
!
!   DESCRIPTION:
!       This program tests the correctness of the EPN-related CAL part by
!       performing a sequence of subroutine calls followed by
!       checks of the output. If any of these checks fails, the
!       program shall exit with a non-zero return value. If all tests
!       succeed 0 will be returned to the calling environment.
!
program caltest

use cal
use errorhandling

    integer :: n

    do n=XMM, OM
        if (instId(n) .ne. instId(instId(instId(n)))) then
           call fatal('caltest_misc', 'problem with instrument ids')
        endif
    enddo

    do n=PRIME_FULL_WINDOW, FLATFIELDING
        if (modeId(n) .ne. modeId(modeId(modeId(n)))) then
           call fatal('caltest_misc', 'problem with mode ids')
        endif
    enddo

    do n=OPEN, BARRED_U
        if (filterId(n) .ne. filterId(filterId(filterId(n)))) then
           call fatal('calctest_misc', 'problem with filter ids')
        endif
    enddo

    call message(AppMsg, Verbose,'All test passed')
end









