! ESA (C) 2000-2018
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!
!   calexample_om.f90 --- example program to show usage of the CAL for OM
!
!   DESCRIPTION:
!       This acts as an example program to show how the CAL
!       is supposed to be used from SAS tasks written in Fortran90.
!
!   AUTHOR:
!       U. Lammers, Fri Nov 14 12:08:05 MET 1997
!
!   $Header: /sasbuild/sas_git_repo/cvs_copy/sasdev/sas/packages/cal/f90test/calexample_om.f90,v 1.20 2007/04/26 09:36:05 rsaxton Exp $
!


program eqpbtest

use cal             ! use the Calibration Access Layer
implicit none

        type(QpbData)               :: qpbd
        integer :: i
        integer(int8), dimension(:), pointer        :: quad => null()
        real(kind=single), dimension(:), pointer :: total_t => null()
        real(kind=single), dimension(:), pointer     :: clean_t => null()
        real(kind=single), dimension(:), pointer     :: exposure => null()
        integer(int32), dimension(:), pointer        :: revolut => null()
        integer(int32), dimension(:), pointer        :: backscal => null()
           real(kind=single), dimension(:), pointer     :: rate, rateerr
            real(kind=single), dimension(:), pointer     :: rate1, rate1err
            real(kind=single), dimension(:), pointer     :: rate2, rate2err
            real(kind=single), dimension(:), pointer     :: rate3, rate3err
            real(kind=single), dimension(:), pointer     :: rate4, rate4err
            real(kind=single), dimension(:), pointer     :: hard1, hard1err
            real(kind=single), dimension(:), pointer     :: hard2, hard2err
            real(kind=single), dimension(:), pointer     :: hard3, hard3err
        integer(int32), dimension(:,:), pointer        :: specp0 => null()
        integer(int32), dimension(:,:), pointer        :: specoop0 => null()
        integer(int32), dimension(:,:), pointer        :: specp4 => null()
        integer(int32), dimension(:,:), pointer        :: specoop4 => null()
        character(len=10) :: obsid
        integer(int32)    :: length


        call CAL_setState(instrument=EPN)

	!qpbd = CAL_getQpbData()

        call CAL_QpbRates(rate, rateerr, rate1, rate1err, rate2, rate2err, &
                                rate3, rate3err, rate4, rate4err)

        write(*, *) 'Qpb values: total_t'
        write(*, *) rate(0), rate(99)

        call CAL_QpbHard(hard1, hard1err, hard2, hard2err, &
                                hard3, hard3err)

        write(*, *) 'Qpb values: Hard'
        write(*, *) hard1(0), hard1(99)

        call CAL_QpbSpec(specp0, specoop0, specp4, specoop4)

        write(*, *) 'Qpb values: SPec'
        write(*, *) specp0(0,0), specp0(100,100)
        write(*, *) specoop0(0,0), specoop0(100,100)
        write(*, *) specp4(0,0), specp4(100,100)
        write(*, *) specoop4(0,0), specoop4(100,100)

        call CAL_QpbTime(quad, total_t, clean_t, exposure, revolut, backscal)
	write(*, *) 'Qpb values: total_t'
	write(*, *) quad(0), quad(99)
	write(*, *) total_t(0), total_t(99)

        call CAL_QpbObsExp(obsid, length)
        write(*, *) 'Qpb values: characters'
        write(*, *) obsid


end program

