! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!
!   timejumptest.f90  --- f90 program to test the time jump access CAL routines
!
!   DESCRIPTION:
!       This gets the time jump tolerance for a given revlution
!
program timejumptest

use cal             ! use the Calibration Access Layer
use dal
use errorhandling

    implicit none
    integer                        :: rev, tol

            call CAL_setState(instrument=EPN)

            rev=500
            tol = CAL_timeJumpTol(rev)

            write(*,*)'Tolerance: ',tol

            call CAL_setState(ccdModeId = PRIME_FULL_WINDOW_EXTENDED)
            tol = CAL_timeJumpTol(rev)
            write(*,*)'Tolerance Extended: ',tol
            call CAL_setState(ccdModeId = PRIME_SMALL_WINDOW)
            tol = CAL_timeJumpTol(rev)
            write(*,*)'Tolerance small: ',tol
            call CAL_setState(ccdModeId = FAST_TIMING)
            tol = CAL_timeJumpTol(rev)
            write(*,*)'Tolerance fast: ',tol
            call CAL_setState(ccdModeId = FAST_BURST)
            tol = CAL_timeJumpTol(rev)
            write(*,*)'Tolerance burst: ',tol

end program


